// KdNode.cpp: implementation of the KdNode class.
//
//////////////////////////////////////////////////////////////////////

#include "KdNode.h"

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

KdNode::KdNode()
{

}

KdNode::KdNode(vector<Vertex *> *pontos, int tipo)
{
	this->pontos=pontos;
	this->type=tipo;
	leftson=rightson=NULL;
	if(pontos->size()>1)
		gerarFilhos();
	else
		P=pontos->at(0);
}

void KdNode::searchkdtree(Vertex *x, vector<Vertex *> *U, double threshold)
{
	double c1=x->a.g(type);
	double c2=P->a.g(type);
	if(fabs(c1-c2)<threshold)
		if(norm(x->a.g-P->a.g)<threshold)
			U->push_back(P);
	if(c1-threshold<c2)
		if(leftson!=NULL)
			leftson->searchkdtree(x,U,threshold);
	if(c2-threshold<c1)
		if(rightson!=NULL)
			rightson->searchkdtree(x,U,threshold);
}

void KdNode::gerarFilhos()
{	
	DBLPRQUE2 *pontosqueue=new DBLPRQUE2();
	for(int i=0;i<pontos->size();i++)
		pontosqueue->push(pontos->at(i)->a.g(type));
	for(int i=0;i<0.5*pontos->size()-1;i++)
		pontosqueue->pop();
	double mediana=pontosqueue->top();
	while(!pontosqueue->empty())
		pontosqueue->pop();
	delete pontosqueue;
	vector<Vertex *> *leftpontos = new vector<Vertex *>();
	vector<Vertex *> *rightpontos = new vector<Vertex *>();
	bool japegouP=false;
	for(int i=0;i<pontos->size();i++)
		if(pontos->at(i)->a.g(type)<=mediana)
		{
			if(pontos->at(i)->a.g(type)==mediana && !japegouP)
			{
				P=pontos->at(i);
				japegouP=true;
			}
			else
				leftpontos->push_back(pontos->at(i));
		}
		else
			rightpontos->push_back(pontos->at(i));
	pontos->clear();
	delete pontos;
	if(leftpontos->size()>0)
		leftson=new KdNode(leftpontos,(type+1)%3);
	else
		leftson=NULL;
	if(rightpontos->size()>0)
		rightson=new KdNode(rightpontos,(type+1)%3);
	else
		rightson=NULL;
}

KdNode::~KdNode()
{
	if(leftson!=NULL)
		delete leftson;
	if(rightson!=NULL)
		delete rightson;
}
