// KdNode.h: interface for the KdNode class.
//
//////////////////////////////////////////////////////////////////////

#pragma once
#include "mesh.h"
#include <queue>
#include <deque>
#include <vector>

using namespace std;
using namespace A48;

typedef deque<double, allocator<double> > DBLDQU;
typedef priority_queue<double,DBLDQU, less<double> > DBLPRQUE2;

class KdNode  
{
public:
	KdNode();
	KdNode(vector<Vertex *> *pontos, int tipo);
	void searchkdtree(Vertex *x, vector<Vertex *> *U, double threshold);
	void gerarFilhos();
	~KdNode();
	bool ehFolha();
	Vertex *P;
	int type;
	KdNode *leftson;
	KdNode *rightson;
	vector<Vertex *> *pontos;
};
