// Kdtree.cpp: implementation of the Kdtree class.
//
//////////////////////////////////////////////////////////////////////

#include "Kdtree.h"

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

Kdtree::Kdtree()
{

}

Kdtree::Kdtree(vector<Vertex *> *pontos)
{
	gerarArvore(pontos); 
}

Vertex *Kdtree::searchkdtree(Vertex *x, double threshold)
{
	vector<Vertex *> *U=new vector<Vertex *>();
	raiz->searchkdtree(x,U,threshold);
	if(U->size()>0)
	{
		double menordist=norm(x->a.g-U->at(0)->a.g);
		Vertex *menorvert=U->at(0);
		double dist;
		for(int i=1;i<U->size();i++)
		{	
			dist=norm(x->a.g-U->at(i)->a.g);
			if(dist<menordist)
			{
				menordist=dist;
				menorvert=U->at(i);
			}
		}
		U->clear();
		delete U;

		return menorvert;
	}
	else
	{
		delete U;
		return NULL;
	}
}

Vertex *Kdtree::searchkdtree(Vec3 xv, double threshold)
{
	Vertex *x=new Vertex();
	x->a.g=xv;
	vector<Vertex *> *U=new vector<Vertex *>();
	raiz->searchkdtree(x,U,threshold);
	if(U->size()>0)
	{
		double menordist=norm(x->a.g-U->at(0)->a.g);
		Vertex *menorvert=U->at(0);
		double dist;
		for(int i=1;i<U->size();i++)
		{	
			dist=norm(x->a.g-U->at(i)->a.g);
			if(dist<menordist)
			{
				menordist=dist;
				menorvert=U->at(i);
			}
		}
		U->clear();
		delete U;

		return menorvert;
	}
	else
	{
		delete U;
		return NULL;
	}
}


void Kdtree::gerarArvore(vector<Vertex *> *pontos)
{
	raiz = new KdNode(pontos,0);
}

Kdtree::~Kdtree()
{
	delete raiz;
}
