#include "a48.h"

//using namespace A48;

namespace A48 {

Mesh *mesh;
int v_i;
Vertex** verts;
HedgeMap* hedges;
double vertex_coords[3];
int face_indx[3];
int actid;

int vertex_cb(p_ply_argument argument) 
{
  double v; long k; 
  ply_get_argument_user_data(argument, NULL, &k);
  v = ply_get_argument_value(argument);
  if (k >= 0 && k <= 2)
    vertex_coords[k] = v;
  if (k==2) {
    verts[v_i] = new Vertex();
	verts[v_i]->id=++actid;
    verts[v_i]->a = Point(vertex_coords[0], vertex_coords[1], vertex_coords[2]);
    mesh->put_vertex(verts[v_i]);
    v_i++;
  } 
  return 1;
}


int face_cb(p_ply_argument argument) 
{
    int i; long length, k;
    ply_get_argument_property(argument, NULL, &length, &k);
    i =  (int) ply_get_argument_value(argument);
    if (k >= 0 && k <= 2) 
      face_indx[k] = i;
    if (k==2) {
      mesh->put_face(face_indx[0], face_indx[1], face_indx[2], verts, hedges);
    }
    return 1;
}


int ply_read_file(char *fname, Mesh *m)
{
  int rc; long nv, nt;
  p_ply ply = ply_open(fname, NULL);
  if (!ply)     
    return 1;
  if (!ply_read_header(ply))     
    return 1;
  actid=-1;
  mesh = m;
  nv = ply_set_read_cb(ply, "vertex", "x", vertex_cb, NULL, 0);
  ply_set_read_cb(ply, "vertex", "y", vertex_cb, NULL, 1);
  ply_set_read_cb(ply, "vertex", "z", vertex_cb, NULL, 2);
  nt = ply_set_read_cb(ply, "face", "vertex_indices", face_cb, NULL, 0);

  v_i = 0;
  verts = new Vertex* [nv];
  hedges = new HedgeMap();
  if (!(rc=ply_read(ply))) {
    ply_close(ply);
  }
  delete(verts);
  delete(hedges);
  return rc;
}

}
