#pragma once

#include <vector>
#include "mesh.h"
#include <gsl/gsl_matrix.h>
#include <gsl/gsl_blas.h>
#include <gsl/gsl_eigen.h>
#include <gsl/gsl_rng.h>
#include <gsl/gsl_linalg.h>

using namespace A48;

typedef struct 
{
Vertex *v;
vector<Vertex *> *v_union;
} UnifiedVertex;

typedef vector<Vertex *> ScanStratification;
typedef vector<UnifiedVertex *> RecStratification;

class Iteration
{
public:
vector<ScanStratification  *> *stratifications;
RecStratification *rec_strat;
vector<gsl_matrix *> *transformations;
Mesh *reconstruction;
Iteration(){ stratifications=new vector<ScanStratification  *>(); rec_strat=NULL; transformations=new vector<gsl_matrix *>(); reconstruction=NULL; }
};


