#ifndef VERTEX_H
#define VERTEX_H
#include <vector>

using namespace std;


namespace A48 {

class Vertex : public  Markable, public MxHeapable {
  friend class Mesh;
  friend class Face;
  Hedge*      s_;    // star hedge

 public:
  Point a;
  Point n; //vetor normal
  Point cor; //cor
  double H; //curvatura mdia
  double G; //curvatura gaussiana
  double k1; //curvatura principal 1
  double k2; //curvatura principal 2
  double k12k22; //curvatura k1^2_k2^2
  bool hasH;
  bool isNearest;
  double weight; // peso
  Vertex *next;
  Vertex *previous;
  Vertex *nearest;
  float erro;

  Vertex() : a(0,0,0) {s_ = NULL; next=previous=nearest=NULL; erro=-1.; isNearest=false;};
  int id;
  bool is_bdry() { return s_->edge()->is_bdry(); };

  Hedge*  star_first() const { return s_; }; 
  Hedge*  star_next(Hedge* h) const {
    if (h->face() == NULL ) return NULL; // other side of boundary
    else { Hedge *n = h->next()->mate(); return (n == s_)? NULL : n; }
  }


 private:
  void set_star(Hedge* h) { s_ = h; }; 
};

}

#endif
